package com.cf.imes.module.system.dal.mysql.notice;

import com.cf.imes.framework.common.enums.CommonStatusEnum;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.framework.mybatis.core.mapper.BaseMapperX;
import com.cf.imes.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.cf.imes.framework.organ.core.context.OrganContextHolder;
import com.cf.imes.framework.security.core.util.SecurityFrameworkUtils;
import com.cf.imes.module.system.controller.admin.notice.vo.NoticePageReqVO;
import com.cf.imes.module.system.dal.dataobject.notice.NoticeDO;
import com.cf.imes.module.system.enums.notice.NoticeSourceEnum;
import org.apache.ibatis.annotations.Mapper;

@Mapper
public interface NoticeMapper extends BaseMapperX<NoticeDO> {

    default PageResult<NoticeDO> selectHomePageNoticePage(NoticePageReqVO reqVO) {
        if (SecurityFrameworkUtils.isSuperAdmin()) {
            // 超管只看内置的
            return selectPage(reqVO, new LambdaQueryWrapperX<NoticeDO>()
                    .likeIfPresent(NoticeDO::getTitle, reqVO.getTitle())
                    .eq(NoticeDO::getSource, NoticeSourceEnum.SYSTEM)
                    .eq(NoticeDO::getStatus, CommonStatusEnum.ENABLE.getStatus())
                    .orderByDesc(NoticeDO::getId));
        }
        // 普通用户查机构下的和内置的
        return selectPage(reqVO, new LambdaQueryWrapperX<NoticeDO>()
                .likeIfPresent(NoticeDO::getTitle, reqVO.getTitle())
                .eqIfPresent(NoticeDO::getStatus, reqVO.getStatus())
                .and(wr -> wr.or(wrapper -> wrapper
                                .eq(NoticeDO::getOrganId, OrganContextHolder.getOrganId())
                                .eq(NoticeDO::getSource, NoticeSourceEnum.CUSTOM))
                        .or(wrapper -> wrapper.eq(NoticeDO::getSource, NoticeSourceEnum.SYSTEM)))
                .orderByDesc(NoticeDO::getId)
                .eq(NoticeDO::getStatus, CommonStatusEnum.ENABLE.getStatus()));
    }

}
